diff --git a/src/backend/utils/cache/catcache.c b/src/backend/utils/cache/catcache.c
index 64776e3..0d807c3 100644
--- a/src/backend/utils/cache/catcache.c
+++ b/src/backend/utils/cache/catcache.c
@@ -2090,3 +2970,593 @@ PrintCatCacheListLeakWarning(CatCList *list)
 		 list->my_cache->cc_relname, list->my_cache->id,
 		 list, list->refcount);
 }
+
+/*
+ * Functions for shared catalog cache
+ */
+
+
+/*
+ * Initialize GlobalCatCache.
+ */
+static void
+InitGlobalCatCache(CatCache *local_cache, GlobalCatCacheMapKey *keyPtr)
+{
+	uint32 hashcode;
+	LWLock *map_lock;
+	GlobalCatCache *gcp;
+	GlobalCatCacheMapEnt *entry;
+	MemoryContext oldcxt;
+	MemoryContext TempGlobalCatCacheContext;
+
+	Assert(local_cache->gcp == NULL);
+
+	/* Get hashcode and lock instance */
+	hashcode = GlobalCatCacheMapHashCode(keyPtr);
+	map_lock = GlobalCatCachePartitionLock(hashcode);
+
+	/* Acquire lock for partition of GlobalCatCacheMap */
+	LWLockAcquire(map_lock, LW_EXCLUSIVE);
+
+	/*
+	 * If someone already registered GlobalCatCache to GlobalCatCacheMap,
+	 * attach and return.
+	 */
+	entry = GlobalCatCacheMapLookup(keyPtr, hashcode);
+
+	if (entry)
+	{
+		local_cache->gcp = entry->gcp;
+		LWLockRelease(map_lock);
+		return;
+	}
+
+	/* Allocate memory and initialize GlobalCatCache */
+
+	TempGlobalCatCacheContext = MemoryContextClone(GlobalCatCacheContext,
+												   CurrentMemoryContext);
+
+	oldcxt = MemoryContextSwitchTo(TempGlobalCatCacheContext);
+	gcp = InitGlobalCatCacheInternal(local_cache);
+	MemoryContextSwitchTo(oldcxt);
+	ShmRetailContextMoveChunk(TempGlobalCatCacheContext, GlobalCatCacheContext);
+
+	/* Insert GlobalCatCache to GlobalCatCacheMap */
+	if (!GlobalCatCacheMapInsert(keyPtr, hashcode, gcp))
+		elog(FATAL, "GlobalCatCache oid: %u, cacheid: %d"
+			 "is already registered to GlobalCatCacheMap",
+			 keyPtr->dbId, keyPtr->cacheId);
+
+	/* Now initialization is done */
+	local_cache->gcp = gcp;
+
+	LWLockRelease(map_lock);
+}
+
+/*
+ * Allocate and build GlobalCatCache
+ */
+static GlobalCatCache *
+InitGlobalCatCacheInternal(CatCache *local_cache)
+{
+	GlobalCatCache *gcp;
+	CatCache *global_cache;
+	size_t sz;
+	int num_locks;
+	int i;
+
+	/*
+	 * Allocate memory for GlobalCatCache and hash buckets as well.
+	 */
+	sz = sizeof(GlobalCatCache) + PG_CACHE_LINE_SIZE;
+	gcp = (GlobalCatCache *) CACHELINEALIGN(palloc0(sz));
+	global_cache = (CatCache *)gcp;
+
+	global_cache->cc_nbuckets = local_cache->cc_nbuckets;
+
+	global_cache->cc_bucket =
+		palloc0(global_cache->cc_nbuckets * sizeof(dlist_head));
+
+	/*
+	 * Allocate memory for bucket locks.
+	 * nbuckets of GlobalCatCache is same as local one at first.
+	 */
+	gcp->gcc_bucket_locks =
+		(LWLock *) palloc(MAX_CC_BUCKET_LOCKS * sizeof(LWLock));
+
+	global_cache->id = local_cache->id;
+	global_cache->cc_type = CC_SHAREDGLOBAL;
+	global_cache->cc_relname = pstrdup(local_cache->cc_relname);
+	global_cache->cc_reloid = local_cache->cc_reloid;
+	global_cache->cc_indexoid = local_cache->cc_indexoid;
+	global_cache->cc_relisshared = local_cache->cc_relisshared;
+	global_cache->cc_ntup = 0;
+	global_cache->cc_nkeys = local_cache->cc_nkeys;
+
+	global_cache->cc_tupdesc = CreateTupleDescCopyConstr(local_cache->cc_tupdesc);
+
+	/* following members are not used in GlobalCatCache */
+	for (i = 0; i < local_cache->cc_nkeys; ++i)
+		global_cache->cc_keyno[i] = local_cache->cc_keyno[i];
+
+	/* Initialize lock for GlobalCatCache members */
+	SpinLockInit(&gcp->gcc_mutex);
+
+	/* Initialize lock partitions of hash table */
+	/* if (global_cache->cc_nbuckets > MAX_CC_BUCKET_LOCKS) */
+	/* 	num_locks = MAX_CC_BUCKET_LOCKS; */
+	/* else */
+	/* 	num_locks = global_cache->cc_nbuckets; */
+	num_locks = MAX_CC_BUCKET_LOCKS;
+
+	for (i = 0; i < num_locks ; ++i)
+		LWLockInitialize(&gcp->gcc_bucket_locks[i],
+						 LWTRANCHE_GLOBAL_CATCACHE);
+
+	/* Initailize handler for Global CatCache entries */
+	InitCacheHandle(&gcp->gcc_handle_hdr, (void *)gcp);
+
+	return gcp;
+}
+
+
+/*
+ * Link local CatCache to global CatCache if available.
+ */
+static GlobalCatCache *
+AttachGlobalCatCache(GlobalCatCacheMapKey *keyPtr)
+{
+	uint32 hashcode;
+	LWLock *map_lock;
+	GlobalCatCacheMapEnt* entry;
+
+	hashcode = GlobalCatCacheMapHashCode(keyPtr);
+	map_lock = GlobalCatCachePartitionLock(hashcode);
+
+	LWLockAcquire(map_lock, LW_SHARED);
+	entry = GlobalCatCacheMapLookup(keyPtr, hashcode);
+	LWLockRelease(map_lock);
+
+	if (!entry)
+		return NULL;
+
+	return entry->gcp;
+}
+
+
+/*
+ * Workhorse of CatalogCacheInitializeCache.
+ * This initailize CatCache whose type is CC_REGULAR and CC_SHAREDLOCAL,
+ * consulting relation and filling in actual members of CatCache.
+ */
+static void
+InitLocalCatCacheInternal(CatCache *cache)
+{
+	Relation	relation;
+	MemoryContext oldcxt;
+	TupleDesc	tupdesc;
+	int			i;
+
+	Assert(cache->cc_type != CC_SHAREDGLOBAL);
+
+	relation = table_open(cache->cc_reloid, AccessShareLock);
+
+	/*
+	 * switch to the cache context so our allocations do not vanish
+	 * at the end of a transaction
+	 */
+	Assert(CacheMemoryContext != NULL);
+	oldcxt = MemoryContextSwitchTo(CacheMemoryContext);
+
+	/*
+	 * copy the relcache's tuple descriptor to permanent cache storage
+	 */
+	tupdesc = CreateTupleDescCopyConstr(RelationGetDescr(relation));
+
+	/*
+	 * save the relation's name and relisshared flag, too (cc_relname is used
+	 * only for debugging purposes)
+	 */
+	cache->cc_relname = pstrdup(RelationGetRelationName(relation));
+	cache->cc_relisshared = RelationGetForm(relation)->relisshared;
+
+	table_close(relation, AccessShareLock);
+
+	CACHE_elog(DEBUG2, "CatalogCacheInitializeCache: %s, %d keys",
+			   cache->cc_relname, cache->cc_nkeys);
+
+	/*
+	 * initialize cache's key information
+	 */
+	for (i = 0; i < cache->cc_nkeys; ++i)
+	{
+		Oid			keytype;
+		RegProcedure eqfunc;
+
+		CatalogCacheInitializeCache_DEBUG2;
+
+		if (cache->cc_keyno[i] > 0)
+		{
+			Form_pg_attribute attr = TupleDescAttr(tupdesc,
+												   cache->cc_keyno[i] - 1);
+
+			keytype = attr->atttypid;
+			/* cache key columns should always be NOT NULL */
+			Assert(attr->attnotnull);
+		}
+		else
+		{
+			if (cache->cc_keyno[i] < 0)
+				elog(FATAL, "sys attributes are not supported in caches");
+			keytype = OIDOID;
+		}
+
+		GetCCHashEqFuncs(keytype,
+						 &cache->cc_hashfunc[i],
+						 &eqfunc,
+						 &cache->cc_fastequal[i]);
+
+		/*
+		 * Do equality-function lookup (we assume this won't need a catalog
+		 * lookup for any supported type)
+		 */
+		fmgr_info_cxt(eqfunc,
+					  &cache->cc_skey[i].sk_func,
+					  CacheMemoryContext);
+
+		/* Initialize sk_attno suitably for HeapKeyTest() and heap scans */
+		cache->cc_skey[i].sk_attno = cache->cc_keyno[i];
+
+		/* Fill in sk_strategy as well --- always standard equality */
+		cache->cc_skey[i].sk_strategy = BTEqualStrategyNumber;
+		cache->cc_skey[i].sk_subtype = InvalidOid;
+		/* If a catcache key requires a collation, it must be C collation */
+		cache->cc_skey[i].sk_collation = C_COLLATION_OID;
+
+		CACHE_elog(DEBUG2, "CatalogCacheInitializeCache %s %d %p",
+				   cache->cc_relname, i, cache);
+	}
+
+	/*
+	 * mark this cache fully initialized
+	 */
+	cache->cc_tupdesc = tupdesc;
+
+	MemoryContextSwitchTo(oldcxt);
+}
+
+/*
+ * Workhorse for SearchCatCacheInternal().
+ * Search the  hash bucket of local/global catcache.  This returns
+ * local/global catctup even if it's a negative one. If not found, return
+ * NULL.
+ * gcc_fastequal is passed only CatCache type is GlobalCatCache
+ * because GlobalCatCache doesn't have function pointer.
+ */
+static CatCTup *
+SearchCatCacheBucket(CatCache *cache, int nkeys, Datum *searchkeys,
+					 uint32 hashValue, Index hashIndex,
+					 const CCFastEqualFN *gcc_fastequal)
+{
+	dlist_head *bucket;
+	dlist_iter	iter;
+	CatCTup* ct;
+	GlobalCatCache *gcp;
+	LWLock *bucket_lock = NULL;
+	const CCFastEqualFN *cc_fastequal;
+	CatCTup *inval_ct = NULL;
+
+	/*
+	 * If catcache is shared among process and located in shared memory
+	 * get lock for bucket and calculate hashIndex
+	 */
+	if (cache->cc_type == CC_SHAREDGLOBAL)
+	{
+		cc_fastequal = gcc_fastequal;
+
+		gcp = (GlobalCatCache *)cache;
+		bucket_lock = GetCatCacheBucketLock(gcp, hashValue);
+		LWLockAcquire(bucket_lock, LW_SHARED);
+
+		hashIndex = HASH_INDEX(hashValue, cache->cc_nbuckets);
+	}
+	else
+		cc_fastequal = cache->cc_fastequal;
+
+	bucket = &cache->cc_bucket[hashIndex];
+
+
+	/*
+	 * scan the hash bucket until we find a match or exhaust our tuples
+	 *
+	 * Note: it's okay to use dlist_foreach here, even though we modify the
+	 * dlist within the loop, because we don't continue the loop afterwards.
+	 */
+	dlist_foreach(iter, bucket)
+	{
+		ct = dlist_container(CatCTup, cache_elem, iter.cur);
+
+		if (ct->hash_value != hashValue)
+			continue;			/* quickly skip entry if wrong hash val */
+
+		/*  Continue. Valid one could be found after we find dummy one. */
+		if (cache->cc_type == CC_SHAREDLOCAL &&  CATC_IS_INVALID_DUMMY((LocalCatCTup *)ct))
+		{
+			inval_ct = ct;
+			continue;
+		}
+
+
+		if (!CatalogCacheCompareTuple(cc_fastequal, nkeys, ct->keys, searchkeys))
+			continue;
+
+		if (ct->dead)
+			continue;			/* ignore dead entries */
+
+		/*
+		 * We found a match in the cache.  Move it to the front of the list
+		 * for its hashbucket, in order to speed subsequent searches.  (The
+		 * most frequently accessed elements in any hashbucket will tend to be
+		 * near the front of the hashbucket's list.) In case of global cache,
+		 * we don't move cache to avoid acquiring exclusive lock.
+		 */
+		if (cache->cc_type != CC_SHAREDGLOBAL)
+			dlist_move_head(bucket, &ct->cache_elem);
+
+		/*
+		 * If it's a positive entry, bump its refcount and return it. If it's
+		 * negative, we can report failure to the caller. If local cache entry
+		 * is a pointer to global entry, keep refcount to zero because there is
+		 * no need to protect tuple which doesn't exist.
+		 */
+		if (!ct->negative)
+		{
+			if (cache->cc_type == CC_REGULAR ||
+				(cache->cc_type == CC_SHAREDLOCAL &&
+				 !((LocalCatCTup *)ct)->lct_committed))
+			{
+				ResourceOwnerEnlargeCatCacheRefs(CurrentResourceOwner);
+				ct->refcount++;
+				ResourceOwnerRememberCatCacheRef(CurrentResourceOwner,
+												 &ct->tuple);
+			}
+			else if (cache->cc_type == CC_SHAREDGLOBAL)
+				IncreaceGlobalCatCTupRefCount((GlobalCatCTup *)ct);
+
+			CACHE_elog(DEBUG2, "SearchCatCacheBucket (%s): found in %s bucket %d",
+					   cache->cc_relname,
+					   ct->my_cache->cc_type == CC_SHAREDGLOBAL ? "global" : "local",
+					   hashIndex);
+
+#ifdef CATCACHE_STATS
+			cache->cc_hits++;
+#endif
+		}
+		else
+		{
+			CACHE_elog(DEBUG2, "SearchCatCache (%s): found neg entry in bucket %d",
+					   cache->cc_relname, hashIndex);
+
+#ifdef CATCACHE_STATS
+			cache->cc_neg_hits++;
+#endif
+		}
+
+		/* Release lock for catctup and bucket */
+		if (cache->cc_type == CC_SHAREDGLOBAL)
+			LWLockRelease(bucket_lock);
+
+		/* return ct in both cases of positive or negative entry */
+		return ct;
+	}
+	/* Reaching here means we cannot find the cache entry in this bucket */
+	if (cache->cc_type == CC_SHAREDGLOBAL)
+		LWLockRelease(bucket_lock);
+
+	/**/
+	return inval_ct;
+}
+
+
+/*
+ * LocalCacheGetValidEntry
+ *
+ * Return the valid CatCTup entry.
+ */
+static CatCTup *
+LocalCacheGetValidEntry(LocalCatCTup *lct)
+{
+	CatCTup *local_ct;
+	GlobalCatCTup *gct;
+	LWLock *handle_lock;
+
+	CACHE_elog(DEBUG2, "LocalCacheGetValidEntry: called");
+
+	/* To access the CatCTup members */
+	local_ct = (CatCTup *)lct;
+
+	/*
+	 * If local cache entry holds its tuple locally or negative, return itself.
+	 * Note refcount of uncommitted one is assumed to be bumped in caller.
+	 */
+	if (local_ct->negative || !lct->lct_committed)
+		return local_ct;
+
+	handle_lock = GET_HANDLE_LOCK(lct->lct_handle);
+
+	/*
+	 * Check if handle is still valid. If it's invalid,
+	 * remove the local entry or mark it as dead.
+	 */
+	LWLockAcquire(handle_lock, LW_SHARED);
+
+	if (CATC_HANDLE_VALID(lct))
+	{
+		gct = lct->lct_handle->entry;
+
+		if (!((CatCTup *)gct)->dead)
+		{
+			/* bump global refcount to keep it in shared memory */
+			IncreaceGlobalCatCTupRefCount(gct);
+
+			LWLockRelease(handle_lock);
+			/* global cache entry is not negative */
+			return &gct->gct_ct;
+		}
+	}
+
+	LWLockRelease(handle_lock);
+
+	/* reaching here means gct is not valid entry */
+
+	if (local_ct->refcount > 0 ||
+		(local_ct->c_list && local_ct->c_list->refcount > 0))
+	{
+		local_ct->dead = true;
+
+		if (local_ct->c_list)
+			local_ct->c_list->dead = true;
+	}
+	else
+		CatCacheRemoveCTup(local_ct->my_cache, local_ct);
+
+	return NULL;
+}
+
+/*
+ * CreateCatCTupWithTuple
+ *
+ * Workhorse for CatalogCacheCreateEntry.
+ * Create catctup struct and following tuple, which is non-negative Regular
+ * entry, SharedLocal uncommitted entry ,or SharedGlobal entry. MemoryContext
+ * should be already switched appropriately.
+ */
+static CatCTup *
+CreateCatCTupWithTuple(CatCache *cache, HeapTuple ntp)
+{
+	CatCTup *ct;
+	HeapTuple	dtp;
+	int i;
+	size_t ct_size;
+
+	/*
+	 * If there are any out-of-line toasted fields in the tuple, expand
+	 * them in-line.  This saves cycles during later use of the catcache
+	 * entry, and also protects us against the possibility of the toast
+	 * tuples being freed before we attempt to fetch them, in case of
+	 * something using a slightly stale catcache entry.
+	 */
+	if (HeapTupleHasExternal(ntp))
+		dtp = toast_flatten_tuple(ntp, cache->cc_tupdesc);
+	else
+		dtp = ntp;
+
+	/*
+	 * To enable type cast among CatCTup, LocalCatCTup and GlobalCatCTup,
+	 * allocate tuple information just after each struct. Members specific to
+	 * LocalCatCTup and GlobalCatCTup is initialized in the caller function.
+	 */
+	if (cache->cc_type == CC_REGULAR)
+		ct_size = sizeof(CatCTup);
+	else if (cache->cc_type == CC_SHAREDLOCAL)
+		ct_size = sizeof(LocalCatCTup);
+	else if (cache->cc_type == CC_SHAREDGLOBAL)
+		ct_size = sizeof(GlobalCatCTup);
+	else
+		elog(FATAL, "unknown cache type %d",cache->cc_type);
+
+	/* Assumed MemoryContext is already switched properly */
+	ct = (CatCTup *) palloc(ct_size +
+							MAXIMUM_ALIGNOF + dtp->t_len);
+
+	ct->tuple.t_len = dtp->t_len;
+	ct->tuple.t_self = dtp->t_self;
+	ct->tuple.t_tableOid = dtp->t_tableOid;
+	ct->tuple.t_data = (HeapTupleHeader)
+		MAXALIGN(((char *) ct) + ct_size);
+	/* copy tuple contents */
+	memcpy((char *) ct->tuple.t_data,
+		   (const char *) dtp->t_data,
+		   dtp->t_len);
+
+	if (dtp != ntp)
+		heap_freetuple(dtp);
+
+	/* extract keys - they'll point into the tuple if not by-value */
+	for (i = 0; i < cache->cc_nkeys; i++)
+	{
+		Datum		atp;
+		bool		isnull;
+
+		atp = heap_getattr(&ct->tuple,
+						   cache->cc_keyno[i],
+						   cache->cc_tupdesc,
+						   &isnull);
+		Assert(!isnull);
+		ct->keys[i] = atp;
+	}
+
+	return ct;
+}
+
+/*
+ * CreateCatCTupWithoutTuple
+ *
+ * Workhorse for CatalogCacheCreateEntry.
+ * Create only catctup struct, which is negative Regular entry or SharedLocal
+ * committed entry. MemoryContext should be already switched appropriately.
+ */
+static CatCTup *
+CreateCatCTupWithoutTuple(CatCache *cache, Datum *arguments)
+{
+	CatCTup *ct;
+
+	/*
+	 * Members of LocalCatCTup is initialized in the caller function.
+	 * Assumed MemoryContext is already switched properly.
+	 */
+	if (cache->cc_type == CC_REGULAR)
+		ct = (CatCTup *) palloc(sizeof(CatCTup));
+	else if (cache->cc_type == CC_SHAREDLOCAL)
+		ct = (CatCTup *) palloc(sizeof(LocalCatCTup));
+	else
+		elog(FATAL, "Global cache entry without tuple is not supported");
+
+	/*
+	 * Store keys - they'll point into separately allocated memory if not
+	 * by-value. If arguments is NULL, it's skip-global dummy.
+	 */
+	if (arguments)
+		CatCacheCopyKeys(cache->cc_tupdesc, cache->cc_nkeys, cache->cc_keyno,
+						 arguments, ct->keys);
+
+	return ct;
+}
+
+
+/*
+ * Get partition lock of Global CatCache hash table
+ */
+static LWLock *
+GetCatCacheBucketLock(GlobalCatCache *gcp, uint32 hashValue)
+{
+	Index hashIndex = HASH_INDEX(hashValue, ((CatCache *)gcp)->cc_nbuckets);
+
+	return &gcp->gcc_bucket_locks[(hashIndex % MAX_CC_BUCKET_LOCKS)];
+}
+
+/*
+ * Bump global refcount to keep it in shared memory
+ */
+static void
+IncreaceGlobalCatCTupRefCount(GlobalCatCTup *gct)
+{
+	SpinLockAcquire(&gct->gct_mutex);
+	((CatCTup *)gct)->refcount++;
+	SpinLockRelease(&gct->gct_mutex);
+
+	CACHE_elog(DEBUG2, "IncreaseGlobalCatCTupRfCount() global refcount is bumped: %s, %d tuple %p",
+			   ((CatCTup *)gct)->my_cache->cc_relname,
+			   ((CatCTup *)gct)->refcount,
+			   &((CatCTup *)gct)->tuple);
+}
diff --git a/src/backend/utils/cache/inval.c b/src/backend/utils/cache/inval.c
index 591dd33..4c63805 100644
--- a/src/backend/utils/cache/inval.c
+++ b/src/backend/utils/cache/inval.c
@@ -106,6 +106,7 @@
 #include "storage/sinval.h"
 #include "storage/smgr.h"
 #include "utils/catcache.h"
+#include "utils/shared_meta_cache.h"
 #include "utils/inval.h"
 #include "utils/memdebug.h"
 #include "utils/memutils.h"
@@ -561,7 +562,7 @@ LocalExecuteInvalidationMessage(SharedInvalidationMessage *msg)
 		{
 			InvalidateCatalogSnapshot();
 
-			SysCacheInvalidate(msg->cc.id, msg->cc.hashValue);
+			SysCacheInvalidate(msg->cc.id, msg->cc.hashValue, INVAL_COMMON);
 
 			CallSyscacheCallbacks(msg->cc.id, msg->cc.hashValue);
 		}
@@ -572,7 +573,7 @@ LocalExecuteInvalidationMessage(SharedInvalidationMessage *msg)
 		{
 			InvalidateCatalogSnapshot();
 
-			CatalogCacheFlushCatalog(msg->cat.catId);
+			CatalogCacheFlushCatalog(msg->cat.catId, INVAL_COMMON);
 
 			/* CatalogCacheFlushCatalog calls CallSyscacheCallbacks as needed */
 		}
@@ -629,6 +630,102 @@ LocalExecuteInvalidationMessage(SharedInvalidationMessage *msg)
 }
 
 /*
+ * GMCEOCommandExecInvalMessage
+ *
+ */
+void
+GMCEOCommandExecInvalMessage(SharedInvalidationMessage *msg)
+{
+	if (msg->id >= 0)
+	{
+		if (msg->cc.dbId == MyDatabaseId || msg->cc.dbId == InvalidOid)
+		{
+			InvalidateCatalogSnapshot();
+
+			/* not end of transaction */
+			SysCacheInvalidate(msg->cc.id, msg->cc.hashValue, INVAL_GMC_EO_COMMAND);
+
+			CallSyscacheCallbacks(msg->cc.id, msg->cc.hashValue);
+		}
+	}
+	else if (msg->id == SHAREDINVALCATALOG_ID)
+	{
+		if (msg->cat.dbId == MyDatabaseId || msg->cat.dbId == InvalidOid)
+		{
+			InvalidateCatalogSnapshot();
+
+			CatalogCacheFlushCatalog(msg->cat.catId, INVAL_GMC_EO_COMMAND);
+
+			/* CatalogCacheFlushCatalog calls CallSyscacheCallbacks as needed */
+		}
+	}
+	else
+		LocalExecuteInvalidationMessage(msg);
+
+}
+
+void
+GMCEOXactExecInvalMessage(SharedInvalidationMessage *msg)
+{
+	if (msg->id >= 0)
+	{
+		if (msg->cc.dbId == MyDatabaseId || msg->cc.dbId == InvalidOid)
+		{
+			//InvalidateCatalogSnapshot() must not be executed
+			/* end of transaction */
+			SysCacheInvalidate(msg->cc.id, msg->cc.hashValue, INVAL_GMC_EO_COMMAND);
+
+			/* Only the global caches entires are flushed */
+			GlobalSysCacheInvalidate(msg->cc.id, msg->cc.hashValue);
+
+			CallSyscacheCallbacks(msg->cc.id, msg->cc.hashValue);
+		}
+	}
+	else if (msg->id == SHAREDINVALCATALOG_ID)
+	{
+		if (msg->cat.dbId == MyDatabaseId || msg->cat.dbId == InvalidOid)
+		{
+			//InvalidateCatalogSnapshot() must not be executed
+
+			CatalogCacheFlushCatalog(msg->cat.catId, INVAL_GMC_COMMIT_XACT);
+
+			/* CatalogCacheFlushCatalog calls CallSyscacheCallbacks as needed */
+		}
+	}
+}
+
+void
+GMCAbortSubXactExecInvalMessage(SharedInvalidationMessage *msg)
+{
+	if (msg->id >= 0)
+	{
+		if (msg->cc.dbId == MyDatabaseId || msg->cc.dbId == InvalidOid)
+		{
+			InvalidateCatalogSnapshot();
+			/* end of transaction */
+			SysCacheInvalidate(msg->cc.id, msg->cc.hashValue, INVAL_GMC_ABORT_SUBXACT);
+
+			CallSyscacheCallbacks(msg->cc.id, msg->cc.hashValue);
+		}
+	}
+	else if (msg->id == SHAREDINVALCATALOG_ID)
+	{
+		if (msg->cat.dbId == MyDatabaseId || msg->cat.dbId == InvalidOid)
+		{
+			InvalidateCatalogSnapshot();
+
+			CatalogCacheFlushCatalog(msg->cat.catId, INVAL_GMC_ABORT_SUBXACT);
+
+			/* CatalogCacheFlushCatalog calls CallSyscacheCallbacks as needed */
+		}
+	}
+	else
+		LocalExecuteInvalidationMessage(msg);
+
+}
+
+
+/*
  *		InvalidateSystemCaches
  *
  *		This blows away all tuples in the system catalog caches and
@@ -968,6 +1065,16 @@ AtEOXact_Inval(bool isCommit)
 		AppendInvalidationMessages(&transInvalInfo->PriorCmdInvalidMsgs,
 								   &transInvalInfo->CurrentCmdInvalidMsgs);
 
+		/*
+		 * If catcache is global mode, try to remove global catcache entry.
+		 * And also local catcaches are removed since  cache tuples added
+		 * in this transaction are located in local CatCache rather than
+		 * global CatCache. We don't want to hold entries locally after commit.
+		 */
+		if (IS_GLOBAL_META_CACHE)
+			ProcessInvalidationMessages(&transInvalInfo->PriorCmdInvalidMsgs,
+										GMCEOXactExecInvalMessage);
+
 		ProcessInvalidationMessagesMulti(&transInvalInfo->PriorCmdInvalidMsgs,
 										 SendSharedInvalidMessages);
 
@@ -1055,8 +1162,12 @@ AtEOSubXact_Inval(bool isCommit)
 	}
 	else
 	{
-		ProcessInvalidationMessages(&myInfo->PriorCmdInvalidMsgs,
-									LocalExecuteInvalidationMessage);
+		if (IS_GLOBAL_META_CACHE)
+			ProcessInvalidationMessages(&myInfo->PriorCmdInvalidMsgs,
+										GMCAbortSubXactExecInvalMessage);
+		else
+			ProcessInvalidationMessages(&myInfo->PriorCmdInvalidMsgs,
+										LocalExecuteInvalidationMessage);
 
 		/* Pop the transaction state stack */
 		transInvalInfo = myInfo->parent;
@@ -1092,8 +1203,13 @@ CommandEndInvalidationMessages(void)
 	if (transInvalInfo == NULL)
 		return;
 
-	ProcessInvalidationMessages(&transInvalInfo->CurrentCmdInvalidMsgs,
-								LocalExecuteInvalidationMessage);
+	if (IS_GLOBAL_META_CACHE)
+		ProcessInvalidationMessages(&transInvalInfo->CurrentCmdInvalidMsgs,
+									GMCEOCommandExecInvalMessage);
+	else
+		ProcessInvalidationMessages(&transInvalInfo->CurrentCmdInvalidMsgs,
+									LocalExecuteInvalidationMessage);
+
 	AppendInvalidationMessages(&transInvalInfo->PriorCmdInvalidMsgs,
 							   &transInvalInfo->CurrentCmdInvalidMsgs);
 }
